#include <vector>
#include <queue>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <iostream>
#include <functional>
#include <cmath>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <windows.h>

#pragma warning( disable: 4996 )

using namespace std;

typedef unsigned long long ull;

template<typename T> inline T sqr(T a) { return a*a; }
template<typename T> inline int size(const T& c) { return (int)c.size(); }

#define zero(a) memset( &a, 0, sizeof(a) )

//#define printf
//#define DBG
//#define VERIFY
#define ERR         -1

#define MAXH        200
#define MAXW        200
#define INF         1000

//#define STDINOUT


struct rectangle {

    rectangle( ) { }
    rectangle( int _x, int _y, int _h, int _w ) : x(_x), y(_y), h(_h), w(_w) { }
    int x, y;
    int h, w;
};


struct compare_height {

    bool operator() ( const rectangle & lhs, const rectangle & rhs ) {

        if ( lhs.h > rhs.h ) {

            return true;
        } else if ( lhs.h < rhs.h ) {

            return false;
        } else {

            return lhs.w > rhs.w;
        }
    }
};


struct compare_width {

    bool operator() ( const rectangle & lhs, const rectangle & rhs ) {

        if ( lhs.w > rhs.w ) {

            return true;
        } else if ( lhs.w < rhs.w ) {

            return false;
        } else {

            return lhs.h > rhs.h;
        }
    }
};


struct region {

    region( int _x, int _y ) : x(_x), y(_y) { area = 0; }

    int x, y;
    int area;
    set< rectangle, compare_height > rect_by_height;
    set< rectangle, compare_width > rect_by_width;
};


struct action {

    action( int _x1, int _y1, int _x2, int _y2, int _h, int _w ) : x1(_x1), y1(_y1), x2(_x2), y2(_y2), h(_h), w(_w) { }
    int x1, y1;
    int x2, y2;
    int h, w;
};


LARGE_INTEGER Start, Now, Diff, Freq;

int H, W, K, Z, T;
int A[ MAXH ][ MAXW ];
int RC[ MAXH ][ MAXW ], GC[ MAXH ][ MAXW ], BC[ MAXH ][ MAXW ];
int R1[ MAXH ][ MAXW ], G1[ MAXH ][ MAXW ], B1[ MAXH ][ MAXW ];
int R2[ MAXH ][ MAXW ], G2[ MAXH ][ MAXW ], B2[ MAXH ][ MAXW ];
int D[ MAXH ][ MAXW ];
int Q[ MAXH * MAXW + 1 ];
bool U[ MAXH ][ MAXW ];
vector< region > I;
vector< pair< double, int > > O;
vector< action > current_sol, best_sol;
double current_diff, best_diff;

int dx[] = { -1,  0,  0, +1 };
int dy[] = {  0, -1, +1,  0 };


void dump_time() {

    long long time_in_ms;

    QueryPerformanceCounter( &Now );
    Diff.QuadPart = Now.QuadPart - Start.QuadPart;
    time_in_ms = ( Diff.QuadPart * 1000 ) / Freq.QuadPart;;
    printf(" %llu\n", time_in_ms);
}


long long get_time() {

    long long time_in_ms;

    QueryPerformanceCounter( &Now );
    Diff.QuadPart = Now.QuadPart - Start.QuadPart;
    time_in_ms = ( Diff.QuadPart * 1000 ) / Freq.QuadPart;

    return time_in_ms;
}


int read_input() {

    int i, j;

#ifdef STDINOUT

    scanf( "%d %d %d", &H, &W, &K );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            scanf( "%d", &R1[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            scanf( "%d", &G1[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            scanf( "%d", &B1[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            scanf( "%d", &R2[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            scanf( "%d", &G2[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            scanf( "%d", &B2[ i ][ j ] );

#else
    FILE *fin = fopen( "transformation.in", "r" );

    if ( fin == NULL ) {

        printf( "Failed to open input file!\n" );
        return ERR;
    }

    fscanf( fin, "%d %d %d", &H, &W, &K );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            fscanf( fin, "%d", &R1[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            fscanf( fin, "%d", &G1[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            fscanf( fin, "%d", &B1[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            fscanf( fin, "%d", &R2[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            fscanf( fin, "%d", &G2[ i ][ j ] );

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            fscanf( fin, "%d", &B2[ i ][ j ] );

    fclose( fin );
#endif

    return 0;
}


int write_output() {

    int k;

    //dump_time();

#ifdef STDINOUT

    printf( "%d\n", size( best_sol ) );

    for ( k = 0; k < size( best_sol ); k++ )
        printf( "%d %d %d %d %d %d\n",
                best_sol[ k ].x2,
                best_sol[ k ].y2,
                best_sol[ k ].x1,
                best_sol[ k ].y1,
                best_sol[ k ].h,
                best_sol[ k ].w );

#else

    FILE *fout = fopen( "transformation.out", "w+" );

    if ( fout == NULL ) {

        printf( "Failed to create output file!\n" );
        return ERR;
    }

    fprintf( fout, "%d\n", size( best_sol ) );

    for ( k = 0; k < size( best_sol ); k++ )
        fprintf( fout,
                 "%d %d %d %d %d %d\n",
                 best_sol[ k ].x2,
                 best_sol[ k ].y2,
                 best_sol[ k ].x1,
                 best_sol[ k ].y1,
                 best_sol[ k ].h,
                 best_sol[ k ].w );

    fclose( fout );

#endif

    return 0;
}


void apply_rectangle( int region_idx, int x1, int y1, int x2, int y2, int h, int w, int p ) {

    int i, j;
    vector< action > res;

    for ( i = 0; i < p && T < K; i++, T++ )
        current_sol.push_back( action( x1, y1, x2, y2, h, w ) );

    I[ region_idx ].rect_by_height.insert( rectangle( x2, y2, h, w ) );
    I[ region_idx ].rect_by_width.insert( rectangle( x2, y2, h, w ) );

    for ( i = x2; i < x2 + h; i++ )
        for ( j = y2; j < y2 + w; j++ )
            U[ i ][ j ] = true;
}


void spread_creap( int region_idx, int x, int y, int h, int w, int h0, int w0, int p ) {

    int i, j, curh, curw;

    curh = h0;
    curw = w0;

    while ( curh < h ) {

            if ( curh * 2 <= h ) {

                for ( i = 0; i < p && T < K; i++, T++ )
                    current_sol.push_back( action( x, y, x + curh, y, curh, curw ) );

                curh *= 2;
            } else {

                for ( i = 0; i < p && T < K; i++, T++ )
                    current_sol.push_back( action( x, y, x + curh, y, h - curh, curw ) );

                curh = h;
            }
    }

    while ( curw < w ) {

            if ( curw * 2 <= w ) {

                for ( i = 0; i < p && T < K; i++, T++ )
                    current_sol.push_back( action( x, y, x, y + curw, curh, curw ) );

                curw *= 2;
            } else {

                for ( i = 0; i < p && T < K; i++, T++ )
                    current_sol.push_back( action( x, y, x, y + curw, curh, w - curw ) );

                curw = w;
            }
    }

    I[ region_idx ].rect_by_height.insert( rectangle( x, y, h, w ) );
    I[ region_idx ].rect_by_width.insert( rectangle( x, y, h, w ) );

    for ( i = x; i < x + h; i++ )
        for ( j = y; j < y + w; j++ )
            U[ i ][ j ] = true;
}


rectangle get_max_rectangle( int region_idx, int x, int y ) {

    int i, j, h, w, prev;

    h = w = 0;
    prev = INF;

    for ( i = x; i < H && A[ i ][ y ] == region_idx && U[ i ][ y ] == false; i++ ) {

        for ( j = y; j < W && A[ i ][ j ] == region_idx && U[ i ][ j ] == false; j++ );

        j = min( prev, j - 1 );
        prev = j;

        if ( ( i - x + 1 ) * ( j - y + 1 ) > h * w ) {

            h = i - x + 1;
            w = j - y + 1;
        }
    }

    return rectangle( x, y, h, w );
}


rectangle find_best_from_available( int region_idx, int h, int w  ) {

    rectangle r1, r2;

    if ( I[ region_idx ].rect_by_height.empty() ) {

        return rectangle( I[ region_idx ].x, I[ region_idx ].y, 1, 1 );
    }

    r1 = *( I[ region_idx ].rect_by_height.begin() );
    r2 = *( I[ region_idx ].rect_by_width.begin() );

    //r1 = *( I[ region_idx ].rect_by_height.lower_bound( rectangle( 0, 0, h, w ) ) );
    //r2 = *( I[ region_idx ].rect_by_width.lower_bound( rectangle( 0, 0, h, w ) ) );

    if ( min( r1.h, h ) * min( r1.w, w ) >= min( r2.h, h ), min( r2.w, w ) ) {

        return rectangle( r1.x, r1.y, min( r1.h, h ), min( r1.w, w ) );
    } else {

        return rectangle( r2.x, r2.y, min( r2.h, h ), min( r2.w, w ) );
    }
}


double pixel_diff( int x, int y ) {

    return sqrt( (double)sqr( RC[ x ][ y ] - R2[ x ][ y ] ) +
                 sqr( GC[ x ][ y ] - G2[ x ][ y ] ) +
                 sqr( BC[ x ][ y ] - B2[ x ][ y ] ) );
}


double pixel_diff( int x1, int y1, int x2, int y2 ) {

    return sqrt( (double)sqr( R2[ x1 ][ y1 ] - R2[ x2 ][ y2 ] ) +
                 sqr( G2[ x1 ][ y1 ] - G2[ x2 ][ y2 ] ) +
                 sqr( B2[ x1 ][ y1 ] - B2[ x2 ][ y2 ] ) );
}


void parse_image( double graduation, bool match_first ) {

    int i, j, k, x, y, xx, yy, qs, qe;
    double diff;

    Z = 0;
    I.clear();
    O.clear();
    zero( A );
    zero( U );

    current_diff = 0;

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            if ( !U[ i ][ j ] ) {

                region r( i, j );
                pair< double, int > o( 0, Z );

                qs = 0;
                qe = 1;

                Q[ qs ] = i * W + j;
                A[ i ][ j ] = Z;
                U[ i ][ j ] = true;

                diff = pixel_diff( i, j );
                o.first += diff;
                current_diff += diff;

                //cout << "region " << Z << " start " << i << "," << j << " with color (" << R2[i][j] << "," << G2[i][j] << "," << B2[i][j] << ")" << endl;

                while ( qs < qe ) {

                    x = Q[ qs ] / W;
                    y = Q[ qs ] % W;
                    qs++;

                    for ( k = 0; k < 4; k++ ) {

                        xx = x + dx[ k ];
                        yy = y + dy[ k ];

                        if ( ( xx < 0 ) ||
                             ( xx >= H ) ||
                             ( yy < 0 ) ||
                             ( yy >= W ) ||
                             ( U[ xx ][ yy ] ) ||
                             ( pixel_diff( x, y, match_first ? i : xx, match_first ? j : yy ) > graduation ) ) continue;

                        //cout << "   (" << xx << "," << yy << ") ";

                        r.area += 1;
                        Q[ qe++ ] = xx * W + yy;
                        A[ xx ][ yy ] = Z;
                        U[ xx ][ yy ] = true;

                        diff = pixel_diff( xx, yy );
                        o.first += diff;
                        current_diff += diff;
                    }
                }

                //cout << endl;

                I.push_back( r );
                O.push_back( o );
                Z++;
            }

    sort( O.begin(), O.end(), greater< pair<double,int> >() );
}


double evaluate_solution( ) {

    int i, j, k, x1, y1, x2, y2;

    //cout << " Z = " << Z << endl;

    current_diff = 0;

    for ( k = 0; k < size( current_sol ); k++ )
        for ( i = 0; i < current_sol[ k ].h; i++ )
            for ( j = 0; j < current_sol[ k ].w; j++ ) {

                x1 = current_sol[ k ].x1;
                y1 = current_sol[ k ].y1;
                x2 = current_sol[ k ].x2;
                y2 = current_sol[ k ].y2;

                RC[ x2 + i ][ y2 + j ] = ( RC[ x1 + i ][ y1 + j ] + RC[ x2 + i ][ y2 + j ] ) / 2;
                GC[ x2 + i ][ y2 + j ] = ( GC[ x1 + i ][ y1 + j ] + GC[ x2 + i ][ y2 + j ] ) / 2;
                BC[ x2 + i ][ y2 + j ] = ( BC[ x1 + i ][ y1 + j ] + BC[ x2 + i ][ y2 + j ] ) / 2;
            }

    for ( i = 0; i < H; i++ )
        for ( j = 0; j < W; j++ )
            current_diff += pixel_diff( i, j );

    return current_diff;
}


void mix_colors( int num_regions, int color_approximation ) {

    int i, j, k, p, x, y;
    int mini, minj;

    //printf("hello\n");


    for ( k = 0; k < min( num_regions, size( O ) ); k++ )
        for ( p = 0; p < 2 * color_approximation; p++ ) {

            x = I[ O[ k ].second ].x;
            y = I[ O[ k ].second ].y;

            //printf("\ncurrent color of region %d is (%d,%d,%d)\n", O[ k ].second, RC[ x ][ y ], GC[ x ][ y ], BC[ x ][ y ] );

            mini = x;
            minj = y;

            for ( i = 0; i < H; i++ )
                for ( j = 0; j < W; j++ ) {

                    if ( !( ( i == x ) && ( j == y ) ) ) {

                        if ( sqrt( sqr( ( RC[ x ][ y ] + RC[ i ][ j ] ) / 2 - R2[ x ][ y ] ) +
                                   sqr( ( GC[ x ][ y ] + GC[ i ][ j ] ) / 2 - G2[ x ][ y ] ) +
                                   sqr( ( BC[ x ][ y ] + BC[ i ][ j ] ) / 2 - B2[ x ][ y ] ) ) < 

                             sqrt( sqr( ( RC[ x ][ y ] + RC[ mini ][ minj ] ) / 2 - R2[ x ][ y ] ) +
                                   sqr( ( GC[ x ][ y ] + GC[ mini ][ minj ] ) / 2 - G2[ x ][ y ] ) +
                                   sqr( ( BC[ x ][ y ] + BC[ mini ][ minj ] ) / 2 - B2[ x ][ y ] ) ) ) {

                                mini = i;
                                minj = j;
                        }
                    }
                }

                if ( ! ( ( mini == x ) && ( minj == y ) ) ) {

                    //printf("(%d,%d) -> (%d,%d)\n", mini, minj, x, y );

                    RC[ x ][ y ] = ( RC[ x ][ y ] + RC[ mini ][ minj ] ) / 2;
                    GC[ x ][ y ] = ( GC[ x ][ y ] + GC[ mini ][ minj ] ) / 2;
                    BC[ x ][ y ] = ( BC[ x ][ y ] + BC[ mini ][ minj ] ) / 2;

                    if ( T < K ) {

                        current_sol.push_back( action( mini, minj, x, y, 1, 1 ) );
                        T++;
                    }
                }
        }
}


void solve( double graduation, bool match_first, int color_approximation ) {

    int i, j, p;

    current_sol.clear();
    T = 0;
    best_diff = 20000000;

    memcpy( RC, R1, sizeof( R1 ) );
    memcpy( GC, G1, sizeof( G1 ) );
    memcpy( BC, B1, sizeof( B1 ) );

    parse_image( graduation, match_first );
    mix_colors( 100, color_approximation );

    zero( U );

    for ( i = 0; i < H && T < K; i++ )
        for ( j = 0; j < W && T < K; j++ )
            if ( !U[ i ][ j ] ) {

                rectangle max_rect = get_max_rectangle( A[ i ][ j ], i, j );
                rectangle best_from_avail = find_best_from_available( A[ i ][ j ], max_rect.h, max_rect.w );

                if ( ( best_from_avail.x == I[ A[ i ][ j ] ].x ) &&
                     ( best_from_avail.y == I[ A[ i ][ j ] ].y ) &&
                     ( best_from_avail.h == 1 ) &&
                     ( best_from_avail.w == 1 ) ) {

                    if ( ! ( ( best_from_avail.x == i ) && ( best_from_avail.y == j ) ) ) {

                        for ( p = 0; p < color_approximation && T < K; p++, T++ ) {

                            current_sol.push_back( action( best_from_avail.x, best_from_avail.y, i, j, 1, 1 ) );
                        }
                    }
                } else {

                    apply_rectangle( A[ i ][ j ],
                                     best_from_avail.x,
                                     best_from_avail.y,
                                     i,
                                     j,
                                     min( best_from_avail.h, max_rect.h ),
                                     min( best_from_avail.w, max_rect.w ),
                                     color_approximation );
                }

                spread_creap( A[ i ][ j ],
                              i,
                              j,
                              max_rect.h,
                              max_rect.w,
                              best_from_avail.h,
                              best_from_avail.w,
                              color_approximation );
            }

    evaluate_solution();
    if ( current_diff < best_diff ) {

        best_sol = current_sol;
        best_diff = current_diff;
    }
}


int main() {

    srand( (int)time(NULL) );

    if ( !QueryPerformanceFrequency( &Freq ) ) {

        printf("QueryPerformanceFrequency() failed! Error = %d\n", GetLastError());
        return ERR;
    }

    if ( !QueryPerformanceCounter( &Start ) ) {

        printf("QueryPerformanceCounter() failed! Error = %d\n", GetLastError());
        return ERR;
    }

    if ( read_input() == ERR ) {

        printf( "read_input() failed!\n" );
        return ERR;
    }

    int z = 210;

    while ( z && get_time() < 10000 ) {

        solve( z, false, 3 );
        z -= 20;
    }
    //printf("Z = %d\n", Z);

    if ( write_output() == ERR ) {

        printf( "write_output() failed!\n" );
        return ERR;
    }

    /*
    vector< action > v;

    v = spread_creap( 0, 0, 10, 20, 4, 4, 1 );

    for ( int i = 0; i < size(v); i++ ) {

        cout << "x1 = "<< v[i].x1 << " y1 = "<< v[i].y1 << " x2 = "<< v[i].x2 << " y2 = "<< v[i].y2 << " h = "<< v[i].h << " w = " << v[i].w << endl;
    }
    */

    /*
    region a;

    a.rect_by_height.insert( rectangle( 1, 1, 1, 1 ) );
    a.rect_by_width.insert( rectangle( 1, 1, 1, 1 ) );

    a.rect_by_height.insert( rectangle( 2, 2, 10, 10 ) );
    a.rect_by_width.insert( rectangle( 2, 2, 10, 10 ) );

    a.rect_by_height.insert( rectangle( 3, 3, 7, 11 ) );
    a.rect_by_width.insert( rectangle( 3, 3, 7, 11 ) );

    a.rect_by_height.insert( rectangle( 4, 4, 4, 3 ) );
    a.rect_by_width.insert( rectangle( 4, 4, 4, 3 ) );

    a.rect_by_height.insert( rectangle( 5, 5, 6, 16 ) );
    a.rect_by_width.insert( rectangle( 5, 5, 6, 16 ) );

    a.rect_by_height.insert( rectangle( 6, 6, 19, 8 ) );
    a.rect_by_width.insert( rectangle( 6, 6, 19, 8 ) );

    a.rect_by_height.insert( rectangle( 7, 7, 200, 5 ) );
    a.rect_by_width.insert( rectangle( 7, 7, 200, 5 ) );

    a.rect_by_height.insert( rectangle( 8, 8, 5, 5 ) );
    a.rect_by_width.insert( rectangle( 8, 8, 5, 5 ) );

    a.rect_by_height.insert( rectangle( 9, 9, 11, 11 ) );
    a.rect_by_width.insert( rectangle( 9, 9, 11, 11 ) );

    a.rect_by_height.insert( rectangle( 10, 10, 12, 9 ) );
    a.rect_by_width.insert( rectangle( 10, 10, 12, 9 ) );

    a.rect_by_height.insert( rectangle( 10, 10, 100, 100 ) );
    a.rect_by_width.insert( rectangle( 10, 10, 100, 100 ) );
    a.rect_by_height.insert( rectangle( 10, 10, 15, 15 ) );
    a.rect_by_width.insert( rectangle( 10, 10, 15, 15 ) );

    rectangle r = find_best_from_available( a, 14, 14 );

    for ( multiset< rectangle >::iterator it = a.rect_by_height.begin(); it != a.rect_by_height.end(); it++ ) {

        cout << "x = " << (*it).x << " y = " << (*it).y << " h = "<< (*it).h << " w = " << (*it).w << endl;
    }


    cout << "x = " << r.x << " y = " << r.y << " h = "<< r.h << " w = " << r.w << endl;
    */

    return 0;
}
